* gdb.base/a2-run.exp: Replace $binfile with $testfile in test result reports.
[deliverable/binutils-gdb.git] / configure.in
CommitLineData
9bdd52dd 1##############################################################################
eb02fd64 2
041164e4
DZ
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
ba4513e7 7
041164e4
DZ
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
ba4513e7 12
041164e4
DZ
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
ba4513e7 15
9bdd52dd 16##############################################################################
041164e4
DZ
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
6d3055cb 27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
041164e4 28
f4a7dca7
TL
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
041164e4
DZ
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
d6c8b354 36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
e718498b 37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
e37bb3c7 38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
bb9ae458 39 recode release sed utils"
041164e4
DZ
40
41
9bdd52dd
DZ
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
041164e4 44#
77cd090a 45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
6218894f 46
041164e4 47
9bdd52dd 48# these tools are built using the target libs, and are intended to run only
9623e828 49# in the target environment
83a47678 50#
9bdd52dd
DZ
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
041164e4 54#
b58d9e5d 55target_tools="target-examples target-groff"
041164e4
DZ
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
ab1cbc67 62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
041164e4
DZ
63## a native environment.
64
65# directories to be built in the native environment only
66#
b58d9e5d 67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
86c3abaa 68 indent ispell m4 rcs recode sed shellutils tar textutils gash
b58d9e5d 69 uudecode wdiff gprof target-groff"
041164e4 70
9bdd52dd 71# directories to be built in a cross environment only
041164e4 72#
ab1cbc67 73cross_only="target-libiberty target-libgloss target-newlib"
041164e4
DZ
74
75## All tools belong in one of the four categories, and are assigned above
8f30a41e
DE
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
ca2ce3b3
ILT
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
041164e4 80#
ca2ce3b3
ILT
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
041164e4
DZ
83
84################################################################################
ba4513e7 85
378fd382 86srctrigger=move-if-change
eb02fd64 87srcname="gnu development package"
0df06ca0 88
af9fa3c1
ILT
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
0df06ca0
RP
92# per-host:
93
594c548a
DM
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
cec673a2 96case "${host}" in
c71350fc 97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
cec673a2
DZ
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
cec673a2 100 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
48de3495
SS
101 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
102 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
e718498b 103 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
031eff55 104 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
e718498b
DZ
105 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
106 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
49ad26c2 107 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
e718498b 108 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
7e290a5d 109 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
a73fc881 110 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
a48876fc 111 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
a73fc881
ILT
112 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
113 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
115 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
116 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
117 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
d3c06c91 118 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
54fdaa7b 119 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
39772dd8 120 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
0259fc73 121 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
c71350fc 122 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
9117f609 123 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
af9fa3c1 124 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
89c27486 125 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
fab5d4e3
DZ
126 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
f4bda0ff 128esac
594c548a 129fi
f4bda0ff 130
ca2ce3b3
ILT
131# See if we can extract a definition of CC from the fragment.
132if [ -z "${CC}" ]; then
4caf3f7d 133 if [ -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
2f9bfdfa
SG
134 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
135 if [ -n "${xx}" ] ; then
136 CC=$xx
137 fi
ca2ce3b3
ILT
138 fi
139fi
140
866cdf6c
ILT
141# The Solaris /usr/ucb/cc compiler does not appear to work.
142case "${host}" in
143 sparc-sun-solaris2*)
144 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
145 could_use=
146 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
147 if [ -d /opt/cygnus/bin ] ; then
80aa1504 148 if [ "$could_use" = "" ] ; then
866cdf6c
ILT
149 could_use="/opt/cygnus/bin"
150 else
151 could_use="$could_use or /opt/cygnus/bin"
152 fi
153 fi
154 if [ "$could_use" = "" ] ; then
155 echo "Warning: compilation may fail because you're using"
156 echo "/usr/ucb/cc. You should change your PATH or CC "
157 echo "variable and rerun configure."
158 else
159 echo "Warning: compilation may fail because you're using"
160 echo "/usr/ucb/cc, when you should use the C compiler from"
161 echo "$could_use. You should change your"
162 echo "PATH or CC variable and rerun configure."
163 fi
164 fi
165 ;;
166esac
167
45329a2c
JM
168# We default to --with-shared on platforms where -fpic is meaningless.
169# Well, we don't yet, but we will.
170if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
171 case "${target}" in
172 alpha-dec-osf*) enable_shared=yes ;;
173 mips-sgi-irix5*) enable_shared=yes ;;
174 *) enable_shared=no ;;
175 esac
176fi
177
178if [ x${enable_shared} = xyes ]; then
179 waugh=
180 case "${host}" in
c9e55665
JM
181 hppa*) waugh=config/mh-papic ;;
182 i[345]86-*) waugh=config/mh-x86pic ;;
183 *) waugh=config/mh-${host_cpu}pic ;;
45329a2c 184 esac
4350753e
JM
185 if [ -f ${srcdir}/${waugh} ]; then
186 if [ -n "${host_makefile_frag}" ] ; then
187 cat ${srcdir}/${host_makefile_frag} > mh-frag
188 cat ${srcdir}/${waugh} >> mh-frag
189 host_makefile_frag=mh-frag
c9e55665
JM
190 else
191 host_makefile_frag=${waugh}
4350753e 192 fi
45329a2c
JM
193 fi
194fi
195
0df06ca0 196# per-target:
bc58b41d 197
9ab10a5b
SEF
198case "${target}" in
199 v810*) target_makefile_frag=config/mt-v810 ;;
138e8532
JM
200 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
201 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
9ab10a5b
SEF
202esac
203
ca2ce3b3 204skipdirs=
719cb03f
DZ
205gasdir=gas
206use_gnu_ld=
207use_gnu_as=
208
9f579565
DZ
209# some tools are so dependent upon X11 that if we're not building with X,
210# it's not even worth trying to configure, much less build, that tool.
211
212case ${with_x} in
e13fa011 213 yes | "") # the default value for this tree is that X11 is available
6a42d184 214 ;;
e13fa011 215 no)
ca2ce3b3 216 skipdirs="${skipdirs} tk gash"
9f579565
DZ
217 ;;
218 *)
219 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
220 ;;
221esac
222
5357f128 223# Some tools are only suitable for building in a "native" situation.
ba4513e7
DZ
224# Those are added when we have a host==target configuration. For cross
225# toolchains, we add some directories that should only be useful in a
226# cross-compiler.
43557c0a 227
2a38983c
DHW
228is_cross_compiler=
229
94028943 230if [ x"${host}" = x"${target}" ] ; then
041164e4
DZ
231 # when doing a native toolchain, don't build the targets
232 # that are in the 'cross only' list
ca2ce3b3 233 skipdirs="${skipdirs} ${cross_only}"
2a38983c 234 is_cross_compiler=no
ab1cbc67 235 target_subdir=.
43557c0a 236else
041164e4
DZ
237 # similarly, don't build the targets in the 'native only'
238 # list when building a cross compiler
ca2ce3b3 239 skipdirs="${skipdirs} ${native_only}"
2a38983c 240 is_cross_compiler=yes
ab1cbc67
PB
241 target_subdir=${target_alias}
242 if [ ! -d ${target_subdir} ] ; then
243 if mkdir ${target_subdir} ; then true
244 else
245 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
246 exit 1
247 fi
248 fi
43557c0a
DZ
249fi
250
055cca84
ILT
251copy_dirs=
252
253# Handle --with-headers=XXX. The contents of the named directory are
52b5deb9 254# copied to $(tooldir)/sys-include.
055cca84
ILT
255if [ x"${with_headers}" != x ]; then
256 if [ x${is_cross_compiler} = xno ]; then
257 echo 1>&2 '***' --with-headers is only supported when cross compiling
258 exit 1
259 fi
260 case "${exec_prefixoption}" in
261 "") x=${prefix} ;;
262 *) x=${exec_prefix} ;;
263 esac
52b5deb9 264 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
055cca84
ILT
265fi
266
267# Handle --with-libs=XXX. Multiple directories are permitted. The
268# contents are copied to $(tooldir)/lib.
269if [ x"${with_libs}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-libs is only supported when cross compiling
272 exit 1
273 fi
274 # Copy the libraries in reverse order, so that files in the first named
275 # library override files in subsequent libraries.
276 case "${exec_prefixoption}" in
277 "") x=${prefix} ;;
278 *) x=${exec_prefix} ;;
279 esac
280 for l in ${with_libs}; do
281 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
282 done
283fi
284
285# If both --with-headers and --with-libs are specified, default to
286# --without-newlib.
287if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
288 if [ x"${with_newlib}" = x ]; then
289 with_newlib=no
290 fi
291fi
292
99dff294 293# Recognize --with-newlib/--without-newlib.
055cca84 294if [ x${with_newlib} = xno ]; then
ab1cbc67 295 skipdirs="${skipdirs} target-newlib"
99dff294 296elif [ x${with_newlib} = xyes ]; then
ab1cbc67 297 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
055cca84
ILT
298fi
299
4f0ad91b
ILT
300# Default to using --with-stabs for certain targets.
301if [ x${with_stabs} = x ]; then
302 case "${target}" in
303 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
304 with_stabs=yes;
305 withoptions="${withoptions} --with-stabs"
306 ;;
307 esac
308fi
309
055cca84
ILT
310# Handle ${copy_dirs}
311set fnord ${copy_dirs}
312shift
313while [ $# != 0 ]; do
314 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
315 :
316 else
317 echo Copying $1 to $2
318
319 # Use the install script to create the directory and all required
320 # parent directories.
321 if [ -d $2 ]; then
322 :
323 else
324 echo >config.temp
325 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
326 fi
327
328 # Copy the directory, assuming we have tar.
329 # FIXME: Should we use B in the second tar? Not all systems support it.
330 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
331
332 # It is the responsibility of the user to correctly adjust all
333 # symlinks. If somebody can figure out how to handle them correctly
334 # here, feel free to add the code.
335
336 echo $1 > $2/COPIED
337 fi
338 shift; shift
339done
340
eebd76cb
SC
341# Configure extra directories which are host specific
342
343case "${host}" in
9daacfc4 344 i[345]86-*-go32*)
a220ba0f 345 configdirs="$configdirs dosrel" ;;
eebd76cb
SC
346esac
347
5357f128 348# Remove more programs from consideration, based on the host or
dfa891fc 349# target this usually means that a port of the program doesn't
8ae559b7 350# exist yet.
dfa891fc 351
52e3ad87
KR
352noconfigdirs=""
353
9f579565 354case "${host}" in
a73fc881 355 i[345]86-*-vsta)
8a3871bb
RS
356 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
357 ;;
a73fc881 358 i[345]86-*-go32)
795f1885 359 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
8c7fd353 360 ;;
9daacfc4
SC
361 *-*-cygwin32)
362 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
9f579565 363 ;;
a51794f1 364 ppc*-*-pe)
9daacfc4 365 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
a51794f1 366 ;;
9f579565 367esac
dfa891fc 368
eebd76cb 369
43557c0a 370case "${target}" in
0f45fbc1 371 *-*-netware)
ab1cbc67 372 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
0f45fbc1 373 ;;
406477a6 374 *-*-vxworks*)
ab1cbc67 375 noconfigdirs="$noconfigdirs target-newlib"
849367a2 376 ;;
6bd3f765
ILT
377 alpha-dec-osf*)
378 # ld works, but does not support shared libraries. emacs doesn't
f4791d95 379 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
2a3486d2
ILT
380 # gas doesn't generate exception information.
381 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
0f45fbc1 382 ;;
04b9315f 383 alpha*-*-*)
6bd3f765 384 # newlib is not 64 bit ready
ab1cbc67 385 noconfigdirs="$noconfigdirs target-newlib"
0f45fbc1 386 ;;
7c71fc39
DE
387# start-sanitize-arc
388 arc-*-*)
7c71fc39
DE
389 ;;
390# end-sanitize-arc
bf150019 391 arm-*-pe*)
bf150019 392 ;;
ff15324f 393 arm-*-riscix*)
318b02b6
KR
394 noconfigdirs="$noconfigdirs ld"
395 ;;
52e3ad87 396 h8300*-*-* | \
8388b9df 397 h8500-*-*)
ab1cbc67 398 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
15ae586e 399 ;;
8a71f0f3 400 hppa*-*-*elf* | \
55ac59da 401 hppa*-*-lites*)
8c92a7d1 402 # Do configure ld/binutils/gas for this case.
99a5da15 403 ;;
15ae586e 404 hppa*-*-*)
408f64bc
JK
405 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
406 # cc is gcc, and on any system a user should be able to link cc to
e37bb3c7 407 # whatever they want. FIXME, emacs emacs19).
8b5405d2 408 case "${CC}" in
e37bb3c7 409 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
772ebace 410 *) ;;
8b5405d2 411 esac
d9f1d487 412 noconfigdirs="$noconfigdirs ld shellutils"
15ae586e 413 ;;
a73fc881 414 i[345]86-*-go32)
632ee4a1 415 # but don't build gdb
ab1cbc67 416 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
8c92a7d1 417 ;;
9daacfc4
SC
418 *-*-cygwin32)
419
600b2f21 420 # make/glob's configure uses some AC_TRY_RUN type tests
77cd090a 421 target_configdirs="$target_configdirs target-winsup"
9daacfc4 422 noconfigdirs="$noconfigdirs tcl tk expect make"
e1a1ddc6 423 # always build newlib.
ab1cbc67 424 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
9daacfc4
SC
425
426 # Can't build gdb for cygwin32 if not native.
427 case "${host}" in
428 *-*-cygwin32) ;; # keep gdb
429 *) noconfigdirs="$noconfigdirs gdb"
430 esac
431
a220ba0f 432 ;;
8c7fd353 433 i[345]86-*-pe)
ab1cbc67 434 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
8c7fd353 435 ;;
a48876fc
SS
436 i[345]86-*-sco3.2v5*)
437 # The linker does not yet know about weak symbols in COFF,
438 # and is not configured to handle mixed ELF and COFF.
439 noconfigdirs="$noconfigdirs gprof ld"
440 ;;
a73fc881 441 i[345]86-*-sco*)
de9117a7
KR
442 noconfigdirs="$noconfigdirs gprof"
443 ;;
a73fc881 444 i[345]86-*-solaris2*)
320c9fff
KR
445 # The linker does static linking correctly, but the Solaris C library
446 # has bugs such that some important functions won't work when statically
447 # linked. (See man pages for getpwuid, for example.)
448 noconfigdirs="$noconfigdirs ld"
449 ;;
a73fc881 450 i[345]86-*-sysv4*)
8b5405d2
DZ
451 # The SYSV4 C compiler doesn't handle Emacs correctly
452 case "${CC}" in
e37bb3c7 453 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
8b5405d2
DZ
454 *) ;;
455 esac
456 # but that's okay since emacs doesn't work anyway
e37bb3c7 457 noconfigdirs="$noconfigdirs emacs emacs19"
8b5405d2 458 ;;
3e1e245d
ILT
459 powerpc-*-aix*)
460 # copied from rs6000-*-* entry
92caaa6a 461 noconfigdirs="$noconfigdirs gprof cvs"
3e1e245d 462 ;;
a51794f1
JM
463 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
464 target_configdirs="$target_configdirs target-winsup"
465 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
466 # always build newlib.
467 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
81d08d0c 468 ;;
2a38983c 469 rs6000-*-lynxos*)
2a38983c
DHW
470 # The CVS server code doesn't work on the RS/6000
471 # Newlib makes problems for libg++ in crosses.
92caaa6a 472 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
2a38983c 473 ;;
8388b9df 474 rs6000-*-*)
92caaa6a 475 noconfigdirs="$noconfigdirs gprof"
fcf4d286 476 ;;
d55a8267
C
477 m68k-*-netbsd*)
478 noconfigdirs="$noconfigdirs gdb"
479 ;;
becf2d8a
JK
480 m68k-apollo-*)
481 noconfigdirs="$noconfigdirs ld binutils gprof"
482 ;;
04b9315f
ILT
483 mips*-*-irix5*)
484 # The GNU linker does not support shared libraries.
82633710
ILT
485 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
486 noconfigdirs="$noconfigdirs ld gprof emacs"
04b9315f 487 ;;
af9fa3c1
ILT
488 mips*-dec-bsd*)
489 noconfigdirs="$noconfigdirs gprof"
490 ;;
491 mips*-*-bsd*)
ffb8885b 492 noconfigdirs="$noconfigdirs gprof"
af9fa3c1 493 ;;
04b9315f 494 mips*-*-*)
52e3ad87 495 noconfigdirs="$noconfigdirs gprof"
fcf4d286 496 ;;
de9117a7 497 romp-*-*)
ca2ce3b3 498 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
de9117a7 499 ;;
817382d1 500 sh-*-*)
719cb03f 501 case "${host}" in
a73fc881 502 i[345]86-*-vsta) ;; # don't add gprof back in
a73fc881 503 i[345]86-*-go32) ;; # don't add gprof back in
ca2ce3b3 504 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
719cb03f
DZ
505 esac
506 ;;
507 sparc-*-sunos4*)
2a38983c 508 if [ x${is_cross_compiler} != xno ] ; then
ab1cbc67 509 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
2a38983c
DHW
510 else
511 use_gnu_ld=no
512 fi
1f69e88d 513 ;;
e08dfe61
DE
514 sparclet-*-*)
515 # Skip these until ready for them.
516 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
e61b005e 517 ;;
486e0f0a 518 v810-*-*)
d25fd70d 519 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
486e0f0a 520 ;;
de9117a7 521 vax-*-vms)
ab1cbc67 522 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
de9117a7
KR
523 ;;
524 vax-*-*)
ab1cbc67 525 noconfigdirs="$noconfigdirs target-newlib"
8388b9df 526 ;;
de9117a7 527 *-*-lynxos*)
19b1d034
SS
528 # Newlib makes problems for libg++ in crosses.
529 noconfigdirs="$noconfigdirs target-newlib"
530 ;;
531 *-*-macos* | \
532 *-*-mpw*)
533 # Macs want a resource compiler.
534 configdirs="$configdirs grez"
535 ;;
05cd8d98
HS
536esac
537
fcfcbf27 538# targets that need a second pass
0807a8af
GN
539case "${target}" in
540 *-gm-magic*)
541 noconfigdirs="$noconfigdirs libgloss"
542 ;;
543esac
544
bfe725ec
ILT
545# If we are building a Canadian Cross, discard tools that can not be built
546# using a cross compiler. FIXME: These tools should be fixed.
547if [ "${build}" != "${host}" ]; then
548 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
549fi
550
d4cf72b3
BK
551# Make sure we don't let GNU ld be added if we didn't want it.
552if [ x$with_gnu_ld = xno ]; then
553 use_gnu_ld=no
554 noconfigdirs="$noconfigdirs ld"
0b0124c6
BK
555fi
556
d4cf72b3
BK
557# Make sure we don't let GNU as be added if we didn't want it.
558if [ x$with_gnu_as = xno ]; then
559 use_gnu_as=no
560 noconfigdirs="$noconfigdirs gas"
0b0124c6
BK
561fi
562
ca2ce3b3
ILT
563# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
564# $target_configdirs.
565# If we have the source for $noconfigdirs entries, add them to $notsupp.
efd7b806 566
52e3ad87 567notsupp=""
ca2ce3b3 568for dir in . $skipdirs $noconfigdirs ; do
b58d9e5d 569 dirname=`echo $dir | sed -e s/target-//g`
1c15a33d 570 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
8f30a41e 571 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
572 if [ -r $srcdir/$dirname/configure ] \
573 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
574 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
575 true
576 else
577 notsupp="$notsupp $dir"
578 fi
579 fi
580 fi
581 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
582 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
583 if [ -r $srcdir/$dirname/configure ] \
584 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
585 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
586 true
587 else
588 notsupp="$notsupp $dir"
589 fi
52e3ad87
KR
590 fi
591 fi
592done
593
fba66802
ILT
594# Sometimes the tools are distributed with libiberty but with no other
595# libraries. In that case, we don't want to build target-libiberty.
596if [ -n "${target_configdirs}" ]; then
597 others=
b58d9e5d 598 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
fba66802
ILT
599 if [ "$i" != "libiberty" ]; then
600 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
601 others=yes;
602 break;
603 fi
604 fi
605 done
606 if [ -z "${others}" ]; then
607 target_configdirs=
608 fi
609fi
610
ca2ce3b3
ILT
611# Deconfigure all subdirectories, in case we are changing the
612# configuration from one where a subdirectory is supported to one where it
613# is not.
ab1cbc67 614if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
b58d9e5d 615 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
ca2ce3b3
ILT
616 rm -f $i/Makefile
617 done
618fi
ab1cbc67 619if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
b58d9e5d 620 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
ab1cbc67
PB
621 rm -f ${target_subdir}/$i/Makefile
622 done
623fi
ca2ce3b3 624
52e3ad87
KR
625# Produce a warning message for the subdirs we can't configure.
626# This isn't especially interesting in the Cygnus tree, but in the individual
627# FSF releases, it's important to let people know when their machine isn't
628# supported by the one or two programs in a package.
629
9fe444b5 630if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
af9fa3c1
ILT
631 # If $appdirs is non-empty, at least one of those directories must still
632 # be configured, or we error out. (E.g., if the gas release supports a
633 # specified target in some subdirs but not the gas subdir, we shouldn't
634 # pretend that all is well.)
635 if [ -n "$appdirs" ]; then
636 for dir in $appdirs ; do
ca2ce3b3
ILT
637 if [ -r $dir/Makefile.in ]; then
638 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
639 appdirs=""
640 break
641 fi
642 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
643 appdirs=""
644 break
645 fi
af9fa3c1
ILT
646 fi
647 done
648 if [ -n "$appdirs" ]; then
649 echo "*** This configuration is not supported by this package." 1>&2
650 exit 1
651 fi
652 fi
653 # Okay, some application will build, or we don't care to check. Still
654 # notify of subdirs not getting built.
52e3ad87
KR
655 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
656 echo " ${notsupp}" 1>&2
657 echo " (Any other directories should still work fine.)" 1>&2
658fi
659
d4cf72b3
BK
660# Set with_gnu_as and with_gnu_ld as appropriate.
661#
662# This is done by determining whether or not the appropriate directory
663# is available, and by checking whether or not specific configurations
664# have requested that this magic not happen.
665#
666# The command line options always override the explicit settings in
667# configure.in, and the settings in configure.in override this magic.
668#
669# If the default for a toolchain is to use GNU as and ld, and you don't
670# want to do that, then you should use the --without-gnu-as and
671# --without-gnu-ld options for the configure script.
672
673if [ x${use_gnu_as} = x ] ; then
674 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
675 with_gnu_as=yes
676 withoptions="$withoptions --with-gnu-as"
677 fi
678fi
679
680if [ x${use_gnu_ld} = x ] ; then
681 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
682 with_gnu_ld=yes
683 withoptions="$withoptions --with-gnu-ld"
684 fi
685fi
686
45329a2c
JM
687if [ x${enable_shared} = xyes ]; then
688 case "${target}" in
c9e55665
JM
689 hppa*) target_makefile_frag=config/mt-papic ;;
690 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
691 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
45329a2c
JM
692 esac
693fi
694
ca2ce3b3
ILT
695# post-target:
696
b5ae8419
ILT
697# Make sure that the compiler is able to generate an executable. If it
698# can't, we are probably in trouble. We don't care whether we can run the
699# executable--we might be using a cross compiler--we only care whether it
700# can be created. At this point the main configure script has set CC.
701echo "int main () { return 0; }" > conftest.c
702${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
703if [ $? = 0 ] && [ -s conftest ]; then
704 :
705else
706 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
707 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
708 rm -f conftest*
709 exit 1
710fi
711rm -f conftest*
712
294fde1f
ILT
713# If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
714# binutils tools will find libbfd.so.
715if [ "${enable_shared}" = "yes" ]; then
716 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
717 Makefile > Makefile.tem
718 rm -f Makefile
719 mv -f Makefile.tem Makefile
720fi
721
ca2ce3b3 722# Record target_configdirs and the configure arguments in Makefile.
ab1cbc67 723target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
ca2ce3b3 724targargs=`echo "${arguments}" | \
7fc36fda
ILT
725 sed -e 's/--norecursion//' \
726 -e 's/--cache[a-z-]*=[^ ]*//' \
727 -e 's/--ho[a-z-]*=[^ ]*//' \
728 -e 's/--ta[a-z-]*=[^ ]*//'`
729
730# Passing a --with-cross-host argument lets the target libraries know
731# whether they are being built with a cross-compiler or being built
732# native. However, it would be better to use other mechanisms to make the
733# sorts of decisions they want to make on this basis. Please consider
734# this option to be deprecated. FIXME.
735if [ x${is_cross_compiler} = xyes ]; then
90bdf864 736 targargs="--with-cross-host=${host_alias} ${targargs}"
7fc36fda
ILT
737fi
738
739targargs="--host=${target_alias} ${targargs}"
ca2ce3b3
ILT
740sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
741 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
ab1cbc67 742 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
ca2ce3b3
ILT
743 Makefile > Makefile.tem
744rm -f Makefile
745mv -f Makefile.tem Makefile
746
bc58b41d
RP
747#
748# Local Variables:
749# fill-column: 131
750# End:
751#
This page took 0.19114 seconds and 4 git commands to generate.